Subject: Re: Simple question about powerpc kernel source.

From: HongWoo Lee <[email-masked]>
Date: Tue, 21 Jul 2009 09:15:41 +0900

-------- Original Message  --------
Subject: Re: Simple question about powerpc kernel source.
From: Benjamin Herrenschmidt <[email-masked]>
To: HongWoo Lee <[email-masked]>
Cc: [email-masked]
Date: Mon Jul 20 2009 19:02:38 GMT+0900
> On Mon, 2009-07-20 at 18:00 +0900, HongWoo Lee wrote:
>   
>> Hi all,
>>
>> I have something to ask for the ppc kernel source.
>>
>> #define LOADADDR(rn,name)           \
>>     lis     rn,name##@highest;      \
>>     ori     rn,rn,name##@higher;    \
>>     rldicr  rn,rn,32,31;            \
>>     oris    rn,rn,name##@h;         \
>>     ori     rn,rn,name##@l
>>
>> Is ## used for concatenation. I'm not sure because it is just meaningless.
>> If so what on earth is the result of concatenating ?
>>
>> And is there a good reference to understand powerpc asm ?
>> I'm reading Power ISA, but I can't find @highest, @higher and ##.
>> It would be good to know the reference book.
>>     
>
> You already asked pretty much the same question with the subject "Simple
> question about powerpc asm" and it was already replied to.
>
> Cheers,
> Ben.
>
>
>   

Thank you, Ben.

First, I aleady understood about @highest, @higher, @h and @l.
For now, what I want to know is about "##" in the below code.

#define LOADADDR(rn,name)           \
    lis     rn,name##@highest;      \
    ori     rn,rn,name##@higher;    \
    rldicr  rn,rn,32,31;            \
    oris    rn,rn,name##@h;         \
    ori     rn,rn,name##@l

And I don't want to ask every detail.
So I want to know the manual or document which describes the detail.

Regards,
HongWoo.